package kojaview.parts;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.SingleVariableDeclaration;
import org.eclipse.jdt.core.dom.Type;
import org.eclipse.jface.viewers.ITreeContentProvider;

public class MyContentProvider implements ITreeContentProvider {
	/**
	 * @override
	 */
	public Object[] getElements(Object inputElement) {
		/* inputElement should be List<MethodDeclaration> */
		if(inputElement instanceof List<?>) {
			List<MethodDeclaration> methods = (List<MethodDeclaration>) inputElement;
			return methods.toArray();
		}
		return null;
	}
	
	/**
	 * @override
	 */
	public void dipose() {}
	
	/**
	 * @override
	 */
	public void inputChanged() {}

	@Override
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof MethodDeclaration) {
			List<Object> list = new LinkedList<Object>();
			MethodDeclaration method = (MethodDeclaration) parentElement;
			list.add(method.getJavadoc());
			list.add(method.getModifiers());         /* Integer */
			list.add(method.getReturnType2());       /* Type */
			list.add(method.parameters());           /* List<SingleVariableDeclaration */
			list.add(method.thrownExceptionTypes()); /* List<Type> */
			return list.toArray();
		} else if(parentElement instanceof Type) {
			List<Object> list = new LinkedList<Object>();
			list.add(((Type)parentElement).toString());      /* String */
		}
		return new Object[0];    // return empty array;
	}

	@Override
	public Object getParent(Object element) {
		if (element instanceof MethodDeclaration) {
			MethodDeclaration method = (MethodDeclaration) element;
			return method;
		}
		return element;
	}

	@Override
	public boolean hasChildren(Object element) {
		return getChildren(element).length > 0;
	}
}
